import requests

class Client:
    url = ""
    result = ""
    account = ""
    password = ""
    token = ""
    version = "Python_1.0.1"
    
    def __init__(self, ):
        self.url = 'https://api.datasoap.co.uk/?output=json'
    
    def WithUsernamePassword(self, username, password):
        self.account = username;
        self.password = password;
    
    def WithAuthToken(self, token):
        self.token = token;
    
    def WithApiBaseUrl(self, url):
        self.url = url + '?output=json'
    
    def Request(self, lookup, type):
        urlBuild = self.url + '&account=' + self.account + '&password=' + self.password + '&type=' + type
        if type == 'Email':
            urlBuild = urlBuild + '&validationEmail=' + lookup
        else :
            urlBuild = urlBuild + '&msisdn=' + lookup

        response = requests.get(urlBuild, headers = {"Lib-Version": self.version,"Authorization": "Token " + self.token})
        return response.json()
    
    def HandleError(self):
        if 'DataSoapAPIResponse' in self.result:
            if 'HLRResult' in self.result['DataSoapAPIResponse']:
                return self.result['DataSoapAPIResponse']['HLRResult']
            return self.result['DataSoapAPIResponse']
        if 'MobileVerificationAPIResponse' in self.result:
            if 'HLRResult' in self.result['MobileVerificationAPIResponse']:
                return self.result['MobileVerificationAPIResponse']['HLRResult']
            return self.result['MobileVerificationAPIResponse']
        return self.result;

    def TpsLookup(self, number):
        self.result = self.Request(number, 'TPS')
        try:
            return self.result['DataSoapAPIResponse']['TPSResult']
        except:
            return self.HandleError()

    def HlrLookup(self, number):
        self.result = self.Request(number, 'HLR')
        try:
            return self.result['DataSoapAPIResponse']['HLRResult']
        except:
            return self.HandleError()

    def LandlineLookup(self, number):
        self.result = self.Request(number, 'Landline')
        try:
            return self.result['DataSoapAPIResponse']['LandlineLookupResult']
        except:
            return self.HandleError()

    def EmailLookup(self, email):
        self.result = self.Request(email, 'Email')
        try:
            return self.result['DataSoapAPIResponse']['EmailValidationResult']
        except:
            return self.HandleError()
    
    def UnsubscribeLookup(self, number):
        self.result = self.Request(number, 'Unsubscribe')
        try:
            return self.result['DataSoapAPIResponse']['UnsubscribeResult']
        except:
            return self.HandleError()